/*
 *	main.c
 *
 *	NSF Player
 *
 *	* Tue Sep 08 05:32:00 JST 2003 Naoyuki Sawa
 *	- VK쐬B
 */
#include "app.h"

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
#define QUICK_REPEAT
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
#define QUICK_REPEAT_DELAY	SEC(0.25)

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

typedef struct _NSFINFO {
	char fname[MAXFILENAME + 1];		/* t@C */
	int size;				/* t@CTCY */
} NSFINFO;

#define MAX_DISP	13			/* Sɕ\łt@C */

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
SURFACE surface;			/* zVRAM̃T[tFCX */
RENDER render;				/* zVRAMւ̕` */

int draw;				/* ĕ`tO */
int now;				/* O[o^C} */
int joy;				/* pbh */

NSFINFO nsf_info[MAXDIR];		/* NSFt@CXg */
int nsf_count;				/* NSFt@C̐   */

int cursel;				/* ݂̑It@CCfNX */
int curtop;				/* ŏi\t@CCfNX */

nsf_t* nsf;				/* tNSFt@C\(Nosefart) */
int track;				/* 0:t@CI[h/1`:݂̑IgbNԍ */
int playing;				/* 0:~/1:t */

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void err_disp(const char* fmt, ...);
void app_init();
void app_exit();
void schedule();
void file_sel();
void track_sel();
void disp();
void nsf_play(nsf_t* nsf, int track);
void nsf_stop();

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	file_sel();

	return 0;
}

/****************************************************************************
 *	err_disp
 ****************************************************************************/

void
err_disp(const char* fmt, ...)
{
	int len, x, y;
	char str[100]; /* ꂮ炢Ώ[H */
	va_list ap;

	va_start(ap, fmt);
	len = vsprintf(str, fmt, ap);
	va_end(ap);

	x = (DISP_X - 5 * len) / 2;
	y = (DISP_Y - 10) / 2;
	memset(vbuff, 0, sizeof vbuff);
	render_string(&render, x, y, str, 0x80, 3);
	draw = 1;
	for(;;) {
		schedule();
		if(joy & (TRG_A | TRG_B | TRG_START | TRG_SELECT)) break;
	}
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

static int
nsf_info_compare(const void* _a, const void* _b)
{
	NSFINFO* a = (NSFINFO*)_a;
	NSFINFO* b = (NSFINFO*)_b;
	return strcmp(a->fname, b->fname);
}

void
app_init()
{
	int retval, len;
	FILEINFO fi;
	NSFINFO* mi;

	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init(&render, &surface, 0, 0, 0, 0, 0, 0, 0);

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* NSFt@CT܂B */
	memset(nsf_info, 0, sizeof nsf_info);
	nsf_count = 0;
	mi = &nsf_info[0];
	retval = pceFileFindOpen(&fi);
	if(retval != 0) DIE();
	while(nsf_count < MAXDIR) {
		retval = pceFileFindNext(&fi);
		if(!retval) break; /* t@CȂ */
		/* gq".nsf"łȂ΁A΂܂B */
		len = strlen(fi.filename);
		if(len < 4) continue;
		if(strcasecmp(&fi.filename[len - 4], ".nsf") != 0) continue;
		/* t@CƃTCYi[܂B */
		if(len > MAXFILENAME) DIE();
		memcpy(mi->fname, fi.filename, len);
		mi->size = fi.length;
		nsf_count++;
		mi++;
	}
	pceFileFindClose(&fi);
	if(nsf_count == 0) {
		err_disp("NSFt@C܂");
		exit(0);
	}

	/* t@CɃ\[gB */
	qsort(nsf_info, nsf_count, sizeof(NSFINFO), nsf_info_compare);

	/* NosefartB */
	nsf_init();

	/* S48MHz[hB */
	turbo(1);
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int x, y;

	/* ɃX^oCɗȂ悤ɁB */
	pceAppActiveResponse(AAR_ACTIVE);

	/* drcʕ\XV̂߁AʍXVvȂĂAb1͋ʍXVB */
	if(now % SEC(1) == 0) {
		draw = 1;
	}

	/* ʍXVB */
	if(draw) {
		pceLCDTrans();
		draw = 0;
	}

	/* VXeB */
	yield();

	/* pbhԍXVB */
	joy = pcePadGet();

	/* O[o^C}XVB */
	now++;

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT
}

/****************************************************************************
 *	file_sel
 ****************************************************************************/

void
file_sel()
{
	NSFINFO* mi;

	disp(); /* ͋` */
	for(;;) {
		schedule();

		/* pbh͂Ȃ΁A܂B */
		if(!joy) continue;

		/* IH */
		if(joy & TRG_SELECT) {
			exit(0);
		}

		/* t@CIύXH */
		if(joy & TRG_UP && cursel > 0             ) cursel--;
		if(joy & TRG_DN && cursel < nsf_count - 1) cursel++;
		if(joy & TRG_LF) {
			cursel -= MAX_DISP;
			if(cursel < 0) cursel = 0;
		}
		if(joy & TRG_RI) {
			cursel += MAX_DISP;
			if(cursel > nsf_count - 1) cursel = nsf_count - 1;
		}
		if(cursel < curtop                 ) curtop = cursel                 ;
		if(cursel > curtop + (MAX_DISP - 1)) curtop = cursel - (MAX_DISP - 1);

		/* ĐJnH */
		if(joy & TRG_A) {
			nsf_stop(); /* t@C񒆂̃mCY}邽߁AIɒ~ */
			mi = &nsf_info[cursel];
			nsf = nsf_load(mi->fname, NULL, 0);
			if(nsf) {
				track_sel();
				nsf_free(&nsf);
			} else {
				err_disp("̧ق͍Đł܂");
				/* p */
			}
		}

		/* ĕ`B */
		disp();
	}
}

/****************************************************************************
 *	track_sel
 ****************************************************************************/

void
track_sel()
{
	track = nsf->start_song;

	disp(); /* ͋` */
	for(;;) {
		schedule();

		/* pbh͂Ȃ΁A܂B */
		if(!joy) continue;

		/* IH */
		if(joy & TRG_SELECT) {
			exit(0);
		}

		/* gbNIύXH */
		if(joy & TRG_LF && track > 1             ) track--;
		if(joy & TRG_RI && track < nsf->num_songs) track++;
		if(joy & TRG_UP) {
			track -= 10;
			if(track < 1) track = 1;
		}
		if(joy & TRG_DN) {
			track += 10;
			if(track > nsf->num_songs) track = nsf->num_songs;
		}

		/* ĐJnH */
		if(joy & TRG_A) {
			playing = 1;
			/*{{ĐdĉʍXVx邱Ƃ̂ŁAɕ`恕XV*/
			disp();
			schedule();
			/*}}ĐdĉʍXVx邱Ƃ̂ŁAɕ`恕XV*/
			nsf_play(nsf, track);
		}

		/* ĐIort@CXg֔H */
		if(joy & TRG_B) {
			if(playing) {
				playing = 0;
				nsf_stop();
			} else {
				break;
			}
		}

		/* ĕ`B */
		disp();
	}

	track = 0;
}

/****************************************************************************
 *	disp
 ****************************************************************************/

void
disp()
{
	int i, x, y, c, i_nsf;
	NSFINFO* mi;

	/* ʓ]B */
	draw = 1;

	/*----- t@CI[h -----*/

	/* t@CXg\B */
	memset(vbuff, 0, sizeof vbuff);
	mi = &nsf_info[curtop];
	y = 8;
	for(i = 0; i < MAX_DISP + 1/*ɏ镪`*/; i++) {
		i_nsf = curtop + i;
		if(i_nsf > nsf_count - 1) break;
		if(i_nsf == cursel) {
			render_rectangle_fill(&render, 0, y - 1, DISP_X, 6 + 1, 2);
			c = 0;
		} else {
			c = 2;
		}
		render_string(&render, 4 + 4 *  1, y, mi->fname, 0x82, c);
		render_printf(&render, 4 + 4 * 15, y, 0x82, c, "%8d bytes", mi->size);
		mi++;
		y += 6;
	}

	/* ^Cg\Biɂ͂ݏot@CXgɏ㏑j */
	render_rectangle_fill(&render, 0, 0, DISP_X, 6 + 1, 3);
	render_string(&render, 0, 1,
	//       0123456789012345678901234567890123
		"=========== NSF Player ===========",
		0x82, 0);

	/* t@CI[hȂA܂ŁB */
	if(!track) return;

	/*----- gbNI[h -----*/

	x = 0;
	y = 8 + 6 * 2;
	render_rectangle_fill(&render, 0, y - 1, DISP_X, 6 * 9 + 1, 3);
	render_string(&render, x + 4, y, "Song name:"    , 0x82, 0); y += 6;
	render_string(&render, x + 8, y, nsf->song_name  , 0x82, 1); y += 6;
	render_string(&render, x + 4, y, "Artist name:"  , 0x82, 0); y += 6;
	render_string(&render, x + 8, y, nsf->artist_name, 0x82, 1); y += 6;
	render_string(&render, x + 4, y, "Copyright:"    , 0x82, 0); y += 6;
	render_string(&render, x + 8, y, nsf->copyright  , 0x82, 1); y += 6;
	render_string(&render, x + 4, y, "Track:"        , 0x82, 0); y += 6;
	render_printf(&render, x +  8, y, 0x82, 1, "%3d/%3d", track, nsf->num_songs); y += 6;
	if(playing) {
		render_string(&render, x + 4, y, "PLAYING...       A:PLAY/B:STOP", 0x82, 0); y += 6;
	} else {
		render_string(&render, x + 4, y, "                 A:PLAY/B:QUIT", 0x82, 0); y += 6;
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

#define NSFBUFLEN 320	/* =16000/50c1[tick](=1/50[sec])̃Tv */

/****************************************************************************
 *	nsf_stream_callback
 ****************************************************************************/

static int
nsf_stream_callback(short* wbuff, int param)
{
	static int elapse; /* 50Hz60Hzϊp */

	nsf_t* nsf = (nsf_t*)param;

	/*{{Œ̃nOAbv*/
	if(pcePadGetDirect() & (PAD_B | PAD_SELECT)) return -1;
	/*}}Œ̃nOAbv*/

	/* CPUG~[VB */
	elapse += 6/*0*/;
	while(elapse >= 5/*0*/) {
		elapse -= 5/*0*/;
		nsf_frame(nsf);
	}

	/* G~[VB */
	/* TODO: 50Hz60Hzϊv邩ȁH */
	apu_process(wbuff, NSFBUFLEN);

	return 0;
}

/****************************************************************************
 *	nsf_play
 ****************************************************************************/

void
nsf_play(nsf_t* nsf, int track)
{
	/* ܂mɒ~܂B */
	nsf_stop();

	/* tgbN܂B */
	nsf_playtrack(nsf, track);

	/* Xg[ĐJn܂B */
	stream_play(NSFBUFLEN, nsf_stream_callback, (int)nsf);
}

/****************************************************************************
 *	nsf_stop
 ****************************************************************************/

void
nsf_stop()
{
	/* Xg[Đ~܂B */
	stream_stop();
}

